#pragma once

class MemoryRenderer;
class MemoryRendererAllocator;

class MemoryRendererInputPin : public CRendererInputPin
{
private:
	MemoryRenderer*					m_pRenderer;
	CCritSec*						m_pInterfaceLock;
	CComPtr<MemoryRendererAllocator> m_pGrabAllocator;
	BOOL							m_activeGrabAllocator;

public:
	MemoryRendererInputPin( MemoryRenderer* pRenderer, CCritSec* pInterfaceLock, HRESULT* phr, LPCWSTR name );
	BOOL ActiveGrabAllocator( void ) const { return m_activeGrabAllocator; }

	// override CRendererInputPin
	STDMETHODIMP GetAllocator( IMemAllocator** ppAllocator );
	STDMETHODIMP NotifyAllocator( IMemAllocator* pAllocator, BOOL bReadOnly );
};
